/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.apt.web.ui.internal.editor.config.BoardConfigWidget");

dojo.require("com.ibm.jdojo.lang.Runtime");
dojo.require("com.ibm.jdojo.util.Assert");
dojo.require("com.ibm.team.apt.api.client.IPlanItem");
dojo.require("com.ibm.team.apt.api.client.IPlanModel");
dojo.require("com.ibm.team.apt.api.common.planning.IViewModeDescription");
dojo.require("com.ibm.team.apt.shared.ui.internal.viewmodes.KanbanViewConfiguration");
dojo.require("com.ibm.team.apt.web.ui.internal.editor.config.BoardConfigWorkItemsGadget");
dojo.require("com.ibm.team.apt.web.ui.internal.editor.config.CheckboxLabelGadget");
dojo.require("com.ibm.team.apt.web.ui.internal.editor.config.ComboLabelGadget");
dojo.require("com.ibm.team.apt.web.ui.internal.editor.config.InputGadget");
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.factories.LabelGadgetFactory");
dojo.require("com.ibm.team.rtc.foundation.web.ui.gadgets.table.styled.StyledTable");
dojo.require("com.ibm.team.workitem.web.mvvm.view.ComboView");
dojo.require("dijit._Widget");
dojo.require("dojo.i18n");

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal.editor.config", "Messages");

(function() {
var Messages= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal.editor.config", "Messages");

var jdojo2= com.ibm.jdojo;
var jdojo= jdojo2.lang.Runtime;
var Assert= jdojo2.util.Assert;
var team= com.ibm.team;
var apt= team.apt;
var api= apt.api;
var client= api.client;
var IPlanItem= client.IPlanItem;
var IPlanModel= client.IPlanModel;
var IViewModeDescription= api.common.planning.IViewModeDescription;
var KanbanViewConfiguration= apt.shared.ui.internal.viewmodes.KanbanViewConfiguration;
var Limit= KanbanViewConfiguration.Limit;
var LimitStrategy= KanbanViewConfiguration.LimitStrategy;
var config= apt.web.ui.internal.editor.config;
var BoardConfigWorkItemsGadget= config.BoardConfigWorkItemsGadget;
var CheckboxLabelGadget= config.CheckboxLabelGadget;
var CheckboxLabelGadgetFactory= CheckboxLabelGadget.CheckboxLabelGadgetFactory;
var ComboLabelGadget= config.ComboLabelGadget;
var InputGadget= config.InputGadget;
var gadgets= team.rtc.foundation.web.ui.gadgets;
var LabelGadgetFactory= gadgets.factories.LabelGadgetFactory;
var StyledTable= gadgets.table.styled.StyledTable;
var ComboViewElement= team.workitem.web.mvvm.view.ComboView.ComboViewElement;
var _Widget= dijit._Widget;

var BoardConfigWidget= dojo.declare("com.ibm.team.apt.web.ui.internal.editor.config.BoardConfigWidget", _Widget, {

	//fInput: null,

	//fBoard: null,

	constructor: function(params) {
		params.planModeData.planMode.getListener().addListener(dojo.hitch(this, 'onChanged'));
		this.fInput= Input.create(params.planModeData.planModel, params.planModeData.planMode);
	},

	postCreate: function() {
		this.inherited("postCreate", arguments, []);
		dojo.addClass(this.domNode, BoardConfigWidget.CLASS_NAME);
		this.createBoard();
	},

	createBoard: function() {
		if (this.fBoard != null) {
			this.fBoard.destroy();
			dojo.empty(this.domNode);
		}
		var boardContainer= dojo.create("div", {className: "boardContainer"}, this.domNode);
		if (this.fInput.isKanban()) {
			this.addKanbanWiPSettings(boardContainer);
		}
		this.fBoard= new StyledTable("com.ibm.team.apt.web.ui.internal.editor.config.BoardConfigWidget");
		var settingsColumn= this.fBoard.addColumn("labelSettings", null, new LabelGadgetFactory(Messages.BoardConfigWidget_COLUMNS_STATEGROUPS), null);
		settingsColumn.addCellClass("settingsColumn");
		settingsColumn.addClass("settingsColumn");
		var stateGroupColumns= this.addStateGroups();
		if (this.fInput.isKanban()) {
			this.addKanbanWiP(this.fBoard, settingsColumn, stateGroupColumns);
		}
		this.addStates(settingsColumn, stateGroupColumns);
		var columnMatrixContainer= dojo.create("div", {className: "column-matrix-container"}, boardContainer);
		dojo.place(this.fBoard.getHTMLElement(), columnMatrixContainer);
	},

	addKanbanWiPSettings: function(parentContainer) {
		var wipSettingsContainer= dojo.create("div", {className: "wipSettingsContainer"}, parentContainer);
		var limitStrategieValues= this.getInputForLimitStrategyCombo();
		var currentStrategy= this.getCurrentStrategy(limitStrategieValues);
		var strictness= new ComboLabelGadget({label: Messages.BoardConfigWidget_WIP_LIMIT_STRATEGY, className: "wipStrategy", selectionChangedCallback: dojo.hitch(this, function(callbackArg) {
			this.fInput.getKanbanConfiguration().setLimitStrategy(LimitStrategy.parseValue(callbackArg.value.id));
			this.fInput.updateConfiguration();
		}), selectedValue: currentStrategy, values: limitStrategieValues});
		dojo.place(strictness.getHTMLElement(), wipSettingsContainer);
		var limitByValues= this.getInputForLimitsByCombo();
		var currentLimitBy= this.getCurrentLimitBy(limitByValues);
		var wipBy= new ComboLabelGadget({label: Messages.BoardConfigWidget_WIP_LIMIT_BY, className: "wipBy", selectionChangedCallback: dojo.hitch(this, function(callbackArg) {
			this.fInput.getKanbanConfiguration().setLimitBy(Limit.parseValue(callbackArg.value.id));
			this.fInput.updateConfiguration();
		}), selectedValue: currentLimitBy, values: limitByValues});
		dojo.place(wipBy.getHTMLElement(), wipSettingsContainer);
	},

	addStateGroups: function() {
		var stateGroupColumns= {};
		var $subject= this.fInput.getStateGroups();
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var stateGroup= $subject[$count];
			var params= {label: stateGroup.getLabel(), iconUri: stateGroup.getIconUri(), checked: !this.fInput.getConfiguration().isStateGroupFiltered(stateGroup), checkListener: this.createStateGroupListener(stateGroup)};
			var stateGroupColumn= this.fBoard.addColumn(stateGroup.getId(), null, new CheckboxLabelGadgetFactory(params), null);
			stateGroupColumn.addCellClass("stateGroupColumn");
			stateGroupColumn.addClass("stateGroupColumn");
			stateGroupColumns[stateGroup.getId()]= stateGroupColumn;
		}
		return stateGroupColumns;
	},

	addKanbanWiP: function(board, settingsColumn, stateGroupColumns) {
		var wipRow= this.fBoard.addRow("wip", null);
		this.addSettingLabel(wipRow.getCellByColumn(settingsColumn), Messages.BoardConfigWidget_COLUMNS_WIP_LIMITS);
		var $subject2= this.fInput.getStateGroups();
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var stateGroup= $subject2[$count2];
			var contentContainer= wipRow.getCellByColumn(stateGroupColumns[stateGroup.getId()]).getGadget().getHTMLElement();
			new InputGadget({inputValueChangeListener: this.createWorkInProgressLimitListener(stateGroup), size: BoardConfigWidget.WIP_INPUT_SIZE, maxLength: BoardConfigWidget.WIP_INPUT_MAXLENGTH, value: this.fInput.getKanbanConfiguration().getExpectedWorkLimitOrEmptyFor(stateGroup)}).placeAt(contentContainer);
		}
	},

	addStates: function(settingsColumn, stateGroupColumns) {
		var statesRow= this.fBoard.addRow("states-row", null);
		this.addSettingLabel(statesRow.getCellByColumn(settingsColumn), Messages.BoardConfigWidget_COLUMNS_STATES);
		statesRow.addClass("states-row");
		var $subject3= this.fInput.getStateGroups();
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var stateGroup3= $subject3[$count3];
			var states= this.fInput.getStatesByStateGroups(stateGroup3);
			var statesContainer= statesRow.getCellByColumn(stateGroupColumns[stateGroup3.getId()]).getGadget().getHTMLElement();
			var $subject4= states;
			var $length4= $subject4.length;
			for (var $count4= 0; $count4 < $length4; $count4++){
				var state= $subject4[$count4];
				var params= {label: state, checked: !this.fInput.getConfiguration().isStateGroupHidingStates(stateGroup3) && !this.fInput.getConfiguration().isStateFiltered(stateGroup3, state), iconUri: this.fInput.getStateIconUri(state), cssClass: "stateLabel", checkListener: this.createStateListener(stateGroup3, state), infoElement: new BoardConfigWorkItemsGadget(this.fInput.getWorkItemTypes(state, stateGroup3)).getHTMLElement()};
				dojo.place(new CheckboxLabelGadget(params).getHTMLElement(), statesContainer);
			}
		}
	},

	getCurrentStrategy: function(limitStrategies) {
		var currentStrategy= null;
		var $subject5= limitStrategies;
		var $length5= $subject5.length;
		for (var $count5= 0; $count5 < $length5; $count5++){
			var strategy= $subject5[$count5];
			if (strategy.id === this.fInput.getKanbanConfiguration().getLimitStrategy().name) {
				currentStrategy= strategy;
				break;
			}
		}
		if (!(currentStrategy != null)) Assert.fail("currentStrategy != null", "BoardConfigWidget:213");
		return currentStrategy;
	},

	getCurrentLimitBy: function(limitByValues) {
		var currentLimit= null;
		var $subject6= limitByValues;
		var $length6= $subject6.length;
		for (var $count6= 0; $count6 < $length6; $count6++){
			var limit= $subject6[$count6];
			if (limit.id === this.fInput.getKanbanConfiguration().getLimit().name) {
				currentLimit= limit;
				break;
			}
		}
		if (!(currentLimit != null)) Assert.fail("currentLimit != null", "BoardConfigWidget:225");
		return currentLimit;
	},

	createWorkInProgressLimitListener: function(stateGroup) {
		return dojo.hitch(this, function(oldValue, newValue) {
			if (dojo.trim(newValue).length === 0) {
				this.fInput.getKanbanConfiguration().removeLimit(stateGroup);
				this.fInput.updateConfiguration();
				return true;
			} else if (!isNaN(newValue)) {
				var limitValue= parseInt(newValue);
				if (limitValue >= 0) {
					this.fInput.getKanbanConfiguration().setLimit(stateGroup, limitValue);
					this.fInput.updateConfiguration();
					return true;
				}
			}
			return false;
		});
	},

	createStateGroupListener: function(stateGroup) {
		return dojo.hitch(this, function(isChecked) {
			this.fInput.getConfiguration().filterStateGroup(stateGroup, !isChecked);
			this.fInput.updateConfiguration();
		});
	},

	createStateListener: function(stateGroup, state) {
		return dojo.hitch(this, function(isChecked) {
			var checkedCount= 0;
			var currentCount= 0;
			var $subject7= this.fInput.getStatesByStateGroups(stateGroup);
			var $length7= $subject7.length;
			for (var $count7= 0; $count7 < $length7; $count7++){
				var state2= $subject7[$count7];
				if (!this.fInput.getConfiguration().isStateFiltered(stateGroup, state2)) {
					checkedCount++;
				}
				if (state2 === state) {
					currentCount++;
				}
			}
			if (!isChecked && checkedCount === currentCount) {
				this.fInput.getConfiguration().hideStateGroupStates(stateGroup, true);
			} else if (isChecked && checkedCount === 0) {
				this.fInput.getConfiguration().hideStateGroupStates(stateGroup, false);
				var $subject8= this.fInput.getStatesByStateGroups(stateGroup);
				var $length8= $subject8.length;
				for (var $count8= 0; $count8 < $length8; $count8++){
					var state3= $subject8[$count8];
					this.fInput.getConfiguration().filterState(stateGroup, state3, true);
				}
			}
			this.fInput.getConfiguration().filterState(stateGroup, state, !isChecked);
			this.fInput.updateConfiguration();
		});
	},

	addSettingLabel: function(tableCell, label) {
		tableCell.setGadgetFactory(new LabelGadgetFactory(label));
	},

	getInputForLimitStrategyCombo: function() {
		var input= [];
		var $subject9= LimitStrategy.values;
		var $length9= $subject9.length;
		for (var $count9= 0; $count9 < $length9; $count9++){
			var limitStrategy= $subject9[$count9];
			input.push(new ComboViewElement(limitStrategy.name, limitStrategy.getLabel()));
		}
		return input;
	},

	getInputForLimitsByCombo: function() {
		var input= [];
		var $subject10= Limit.values;
		var $length10= $subject10.length;
		for (var $count10= 0; $count10 < $length10; $count10++){
			var limit= $subject10[$count10];
			input.push(new ComboViewElement(limit.name, limit.getLabel()));
		}
		return input;
	},

	setInput: function(planModel, planMode) {
		this.updatePlanModeListener(planMode);
		this.reloadBoard(planModel, planMode);
	},

	reloadBoard: function(planModel, planMode) {
		if (BoardConfigWidget.isBoard(planMode.getViewMode())) {
			var newInput= Input.create(planModel, planMode);
			if (newInput != null) {
				this.fInput= newInput;
				this.createBoard();
			}
		}
	},

	updatePlanModeListener: function(planMode) {
		if (this.fInput != null) {
			this.fInput.fPlanMode.getListener().removeListener(dojo.hitch(this, 'onChanged'));
		}
		planMode.getListener().addListener(dojo.hitch(this, 'onChanged'));
	},

	onChanged: function(type, planMode) {
		this.reloadBoard(this.fInput.getPlanModel(), planMode);
	},

	$interfaces: {
		'com.ibm.team.apt.web.ui.internal.editor.config.ResolvedPlanMode.IResolvedPlanModeListener': true
	}
});
var Input= dojo.declare("com.ibm.team.apt.web.ui.internal.editor.config.BoardConfigWidget.Input", null, {
	"-chains-": { constructor: "manual" },

	//fStateGroups: null,

	//fStateLabelsByStateGroupIds: null,

	//fPlanModel: null,

	//fPlanMode: null,

	//fStatesByLabel: null,

	//fConfiguration: null,

	//fWorkItemTypeFinder: null,

	constructor: function(stateGroups, statesByStateGroup, planModel, planMode, statesByLabel, workItemTypeFinder) {
		this.fStateGroups= stateGroups;
		this.fStateLabelsByStateGroupIds= statesByStateGroup;
		this.fPlanModel= planModel;
		this.fPlanMode= planMode;
		this.fStatesByLabel= statesByLabel;
		this.fConfiguration= this.extractConfiguration(planMode);
		this.fWorkItemTypeFinder= workItemTypeFinder;
	},

	extractConfiguration: function(planMode) {
		var boardViewMode= planMode.getViewModelTransformer(this);
		return boardViewMode.getViewConfiguration();
	},

	getStateIconUri: function(stateLabel) {
		return this.fStatesByLabel[stateLabel].getIconUri();
	},

	getConfiguration: function() {
		return this.fConfiguration;
	},

	getKanbanConfiguration: function() {
		if (!(this.isKanban())) Assert.fail("this.isKanban()", "BoardConfigWidget:374");
		return this.fConfiguration;
	},

	getStateGroups: function() {
		return this.fStateGroups;
	},

	getStatesByStateGroups: function(stateGroup) {
		var states= this.fStateLabelsByStateGroupIds[stateGroup.getId()];
		return states == null ? [] : states;
	},

	updateConfiguration: function() {
		this.fPlanMode.replaceConfigurationElement(this.fConfiguration.getConfiguration(), this.fConfiguration.getUpdatedConfiguration());
	},

	getWorkItemTypes: function(state, stateGroup) {
		return this.fWorkItemTypeFinder.getWorkItemTypes(state, stateGroup);
	},

	isKanban: function() {
		return this.fPlanMode.getViewMode().getImplementationName() === IViewModeDescription.KANBAN_CTOR;
	},

	getPlanModel: function() {
		return this.fPlanModel;
	},

	$interfaces: {
		'com.ibm.team.apt.api.ui.essentials.IPlanModelContext': true
	}
});
var WorkItemTypeComparator= dojo.declare("com.ibm.team.apt.web.ui.internal.editor.config.BoardConfigWidget.WorkItemTypeComparator", null, {
	"-chains-": { constructor: "manual" },

	compare: function(left, right) {
		return left.getLabel().localeCompare(right.getLabel());
	},

	$interfaces: {
		'com.ibm.jdojo.util.JSArrays.IComparator': true
	}
});
var WorkItemTypeFinder= dojo.declare("com.ibm.team.apt.web.ui.internal.editor.config.BoardConfigWidget.WorkItemTypeFinder", null, {
	"-chains-": { constructor: "manual" },

	//fPlanModel: null,

	//fAllWorkflows: null,

	//fAllStateGroups: null,

	//fTypeComparator: null,

	//allValues: null,

	//fWorkItemTypeByWorkflowId: null,

	//fWorkflowByStateGroupAndState: null,

	constructor: function(planModel, allWorkflows, allStateGroups) {
		this.fPlanModel= planModel;
		this.fAllWorkflows= allWorkflows;
		this.fAllStateGroups= allStateGroups;
		this.fTypeComparator= new WorkItemTypeComparator();
	},

	getWorkItemTypes: function(state, stateGroup) {
		if (this.fWorkflowByStateGroupAndState == null) {
			this._load();
		}
		var infos= this.fWorkflowByStateGroupAndState[this._createLookupKey(stateGroup, state)];
		var types= dojo.map(infos, dojo.hitch(this, function(element, index, array) {
			return this.fWorkItemTypeByWorkflowId[element.getId()];
		}));
		return types.sort(dojo.hitch(this.fTypeComparator, 'compare'));
	},

	_createLookupKey: function(stateGroup, stateLabel) {
		return "StateGroup:" + stateGroup.getId() + "-State:" + stateLabel;
	},

	_getWorkflow: function(allWorkflows, type) {
		var $subject15= allWorkflows;
		var $length15= $subject15.length;
		for (var $count15= 0; $count15 < $length15; $count15++){
			var info= $subject15[$count15];
			if ((type.getWorkflow() === info.getId())) {
				return info;
			}
		}
		return null;
	},

	_load: function() {
		this.fWorkItemTypeByWorkflowId= {};
		this.fWorkflowByStateGroupAndState= {};
		var valueSet= this.fPlanModel.findAttribute(IPlanItem.ITEM_TYPE).getValueSet(null);
		this.allValues= valueSet.getAllValues();
		var $subject16= this.allValues;
		var $length16= $subject16.length;
		for (var $count16= 0; $count16 < $length16; $count16++){
			var type= $subject16[$count16];
			var workflow= this._getWorkflow(this.fAllWorkflows, type);
			if (workflow != null) {
				this.fWorkItemTypeByWorkflowId[workflow.getId()]= type;
			}
		}
		var workflowInfoAttribute= this.fPlanModel.findAttribute(IPlanModel.WORKFLOW_INFOS);
		var $subject17= this.fAllWorkflows;
		var $length17= $subject17.length;
		for (var $count17= 0; $count17 < $length17; $count17++){
			var workflow= $subject17[$count17];
			var $subject18= this.fAllStateGroups;
			var $length18= $subject18.length;
			for (var $count18= 0; $count18 < $length18; $count18++){
				var stateGroup= $subject18[$count18];
				var $subject19= workflow.getStates();
				var $length19= $subject19.length;
				for (var $count19= 0; $count19 < $length19; $count19++){
					var stateHandle= $subject19[$count19];
					if (stateGroup.containsState(stateHandle)) {
						var key= this._createLookupKey(stateGroup, workflowInfoAttribute.getResolvedState(stateHandle).getLabel());
						var infos= this.fWorkflowByStateGroupAndState[key];
						if (infos == null) {
							infos= [];
						}
						infos.push(workflow);
						this.fWorkflowByStateGroupAndState[key]= infos;
					}
				}
			}
		}
	}
});

BoardConfigWidget.WIP_INPUT_MAXLENGTH= 4;
BoardConfigWidget.WIP_INPUT_SIZE= "3";
BoardConfigWidget.CLASS_NAME= "com-ibm-team-apt-web-ui-internal-editor-config-BoardConfigWidget";
BoardConfigWidget.isBoard= function(viewMode) {
	return viewMode != null && (viewMode.getImplementationName() === IViewModeDescription.KANBAN_CTOR || viewMode.getImplementationName() === IViewModeDescription.TASK_BOARD_CTOR);
};
Input.create= function(planModel, planMode) {
	var result= null;
	var stateLabelsByStateGroupIds= {};
	var statesByLabel= {};
	var workflowInfoAttribute= planModel.findAttribute(IPlanModel.WORKFLOW_INFOS);
	var allWorkflows= workflowInfoAttribute.getAllWorkflows(planModel);
	if (allWorkflows.length > 0) {
		var stateGroupAttribute= planModel.findAttribute(IPlanItem.WORKFLOW_STATEGROUP);
		var allStateGroups= stateGroupAttribute.getValueSet(null).getAllValues();
		var $subject11= allWorkflows;
		var $length11= $subject11.length;
		for (var $count11= 0; $count11 < $length11; $count11++){
			var workflow= $subject11[$count11];
			var $subject12= allStateGroups;
			var $length12= $subject12.length;
			for (var $count12= 0; $count12 < $length12; $count12++){
				var stateGroup= $subject12[$count12];
				var $subject13= workflow.getStates();
				var $length13= $subject13.length;
				for (var $count13= 0; $count13 < $length13; $count13++){
					var stateHandle= $subject13[$count13];
					if (stateGroup.containsState(stateHandle)) {
						if (!(stateGroup.getId() in stateLabelsByStateGroupIds)) {
							stateLabelsByStateGroupIds[stateGroup.getId()]= {};
						}
						var grpStates= stateLabelsByStateGroupIds[stateGroup.getId()];
						var resolvedState= workflowInfoAttribute.getResolvedState(stateHandle);
						grpStates[resolvedState.getLabel()]= true;
						if (!(resolvedState.getLabel() in statesByLabel)) {
							statesByLabel[resolvedState.getLabel()]= resolvedState;
						}
					}
				}
			}
		}
		var statesByStateGroup= {};
		var stateGroupIds= jdojo.getProperties(stateLabelsByStateGroupIds);
		var $subject14= stateGroupIds;
		var $length14= $subject14.length;
		for (var $count14= 0; $count14 < $length14; $count14++){
			var stateGroupId= $subject14[$count14];
			statesByStateGroup[stateGroupId]= jdojo.getProperties(stateLabelsByStateGroupIds[stateGroupId]);
		}
		result= new Input(allStateGroups, statesByStateGroup, planModel, planMode, statesByLabel, new WorkItemTypeFinder(planModel, allWorkflows, allStateGroups));
	}
	return result;
};

})();
